type Callback = (...args: any[]) => void;
type Subscription = {
    callback: Callback;
    once: boolean;
};
type EventType = string | symbol;
type Events<T = Subscription> = Map<EventType, T[]>;
interface EventOptions {
    /**
     * Subscriptions are notified of events only once.
     */
    once?: boolean;
    /**
     * Subscribe to priority notifications for the current event.
     */
    priority?: boolean;
}
export declare class EventEmitter {
    protected _events: Events;
    on(eventType: EventType, callback: Callback, { once, priority }?: EventOptions): void;
    off(eventType: EventType, callback: Callback): void;
    remove(eventType: EventType): boolean;
    emit(eventType: EventType, ...args: any[]): void;
}
export {};
//# sourceMappingURL=event.d.ts.map